#include "obj07_db_api.h"
#include "obj07_db_dbd.h"

using namespace RDM_CPP;

Db_obj07_db Db_obj07_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj07_db", mode, &obj07_db_dbd, sizeof(obj07_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj07_db Db_obj07_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj07_db", mode, &obj07_db_dbd, sizeof(obj07_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj07_db Db_obj07_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj07_db_dbd, sizeof(obj07_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj07_db Db_obj07_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj07_db_dbd, sizeof(obj07_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj07_db::Type (void) {
    char static type;
    return &type;
}

Db_obj07_db::Db_obj07_db (void) throw () {
}

Db_obj07_db::Db_obj07_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj07_db::Db_obj07_db (const Db_obj07_db& db) throw () : Db (db) {
}

Db_obj07_db::Db_obj07_db (IDb *idb) : Db (idb) {
}

Db_obj07_db& Db_obj07_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj07_db& Db_obj07_db::operator = (const Db_obj07_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj07_db::~Db_obj07_db () {
}

Cursor_student Db_obj07_db::New_student_record (void) const throw (rdm_exception&) {
    return Cursor_student (NewRecords (Cursor_student::Type ()));
}

Cursor_student Db_obj07_db::New_student_recordWithFieldValues (struct student *fields) const throw (rdm_exception&) {
    return Cursor_student (NewRecordsWithFieldValues (Cursor_student::Type (), fields));
}

Cursor_course Db_obj07_db::New_course_record (void) const throw (rdm_exception&) {
    return Cursor_course (NewRecords (Cursor_course::Type ()));
}

Cursor_course Db_obj07_db::New_course_recordWithFieldValues (struct course *fields) const throw (rdm_exception&) {
    return Cursor_course (NewRecordsWithFieldValues (Cursor_course::Type (), fields));
}

Cursor_course_registration Db_obj07_db::New_course_registration_record (void) const throw (rdm_exception&) {
    return Cursor_course_registration (NewRecords (Cursor_course_registration::Type ()));
}

Cursor_course_registration Db_obj07_db::New_course_registration_recordWithFieldValues (struct course_registration *fields) const throw (rdm_exception&) {
    return Cursor_course_registration (NewRecordsWithFieldValues (Cursor_course_registration::Type (), fields));
}

Cursor_student Db_obj07_db::Get_student_records (void) const throw (rdm_exception&) {
    return Cursor_student (GetRecords (Cursor_student::Type ()));
}

Cursor_course Db_obj07_db::Get_course_records (void) const throw (rdm_exception&) {
    return Cursor_course (GetRecords (Cursor_course::Type ()));
}

Cursor_course_registration Db_obj07_db::Get_course_registration_records (void) const throw (rdm_exception&) {
    return Cursor_course_registration (GetRecords (Cursor_course_registration::Type ()));
}

Cursor_student Db_obj07_db::Get_student_recordsBy_name () const throw (rdm_exception&) {
    return Cursor_student (GetRecordsByKey (STUDENT_NAME));
}

Cursor_course Db_obj07_db::Get_course_recordsBy_id () const throw (rdm_exception&) {
    return Cursor_course (GetRecordsByKey (COURSE_ID));
}

recordType Cursor_student::Type (void) {
    return STUDENT;
}

Cursor_student::Cursor_student (void) throw () {
}

Cursor_student::Cursor_student (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_student::Cursor_student (const Cursor_student& cursor) throw () : Cursor (cursor) {
}

Cursor_student& Cursor_student::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_student& Cursor_student::operator = (const Cursor_student& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_course_registration Cursor_student::Get_attends_members (void) const throw (rdm_exception&) {
    return GetMembers (ATTENDS);
}

int32_t Cursor_student::Get_attends_count (void) const throw (rdm_exception&) {
    return GetMemberCount (ATTENDS);
}

Cursor_student Cursor_student::GetRecordsBy_name () const throw (rdm_exception&) {
    return Cursor_student (GetRecordsByKey (STUDENT_NAME));
}

void Cursor_student::KeyFindBy_name (char name_val[100]) const throw (rdm_exception&) {
    FindRecordsByKey(STUDENT_NAME, 0, 0, name_val);
}

void Cursor_student::SetFieldValues (const struct student *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_student::GetFieldValues (struct student *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_student::Set_name (const char name_val[100]) const throw (rdm_exception&) {
    SetField (STUDENT_NAME, name_val);
}

void Cursor_student::Get_name (char name_val[100]) const throw (rdm_exception&) {
    GetField (STUDENT_NAME, name_val);
}

Cursor_student::~Cursor_student () {
}

recordType Cursor_course::Type (void) {
    return COURSE;
}

Cursor_course::Cursor_course (void) throw () {
}

Cursor_course::Cursor_course (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_course::Cursor_course (const Cursor_course& cursor) throw () : Cursor (cursor) {
}

Cursor_course& Cursor_course::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_course& Cursor_course::operator = (const Cursor_course& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_course_registration Cursor_course::Get_attended_by_members (void) const throw (rdm_exception&) {
    return GetMembers (ATTENDED_BY);
}

int32_t Cursor_course::Get_attended_by_count (void) const throw (rdm_exception&) {
    return GetMemberCount (ATTENDED_BY);
}

Cursor_course Cursor_course::GetRecordsBy_id () const throw (rdm_exception&) {
    return Cursor_course (GetRecordsByKey (COURSE_ID));
}

void Cursor_course::KeyFindBy_id (char id_val[10]) const throw (rdm_exception&) {
    FindRecordsByKey(COURSE_ID, 0, 0, id_val);
}

void Cursor_course::SetFieldValues (const struct course *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_course::GetFieldValues (struct course *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_course::Set_id (const char id_val[10]) const throw (rdm_exception&) {
    SetField (COURSE_ID, id_val);
}

void Cursor_course::Get_id (char id_val[10]) const throw (rdm_exception&) {
    GetField (COURSE_ID, id_val);
}

void Cursor_course::Set_title (const char title_val[100]) const throw (rdm_exception&) {
    SetField (COURSE_TITLE, title_val);
}

void Cursor_course::Get_title (char title_val[100]) const throw (rdm_exception&) {
    GetField (COURSE_TITLE, title_val);
}

Cursor_course::~Cursor_course () {
}

recordType Cursor_course_registration::Type (void) {
    return COURSE_REGISTRATION;
}

Cursor_course_registration::Cursor_course_registration (void) throw () {
}

Cursor_course_registration::Cursor_course_registration (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_course_registration::Cursor_course_registration (const Cursor_course_registration& cursor) throw () : Cursor (cursor) {
}

Cursor_course_registration& Cursor_course_registration::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_course_registration& Cursor_course_registration::operator = (const Cursor_course_registration& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_course_registration Cursor_course_registration::Get_attends_siblings (void) const throw (rdm_exception&) {
    return GetSiblings (ATTENDS);
}

void Cursor_course_registration::Connect_attends (const Cursor_student &owner) const throw (rdm_exception&) {
    Connect (ATTENDS, owner, FALSE);
}

void Cursor_course_registration::Reconnect_attends (const Cursor_student &owner) const throw (rdm_exception&) {
    Connect (ATTENDS, owner, TRUE);
}

void Cursor_course_registration::Disconnect_attends (void) const throw (rdm_exception&) {
    Disconnect (ATTENDS);
}

Cursor_student Cursor_course_registration::Get_attends_owner (void) const throw (rdm_exception&) {
    return GetOwner (ATTENDS);
}

Cursor_course_registration Cursor_course_registration::Get_attended_by_siblings (void) const throw (rdm_exception&) {
    return GetSiblings (ATTENDED_BY);
}

void Cursor_course_registration::Connect_attended_by (const Cursor_course &owner) const throw (rdm_exception&) {
    Connect (ATTENDED_BY, owner, FALSE);
}

void Cursor_course_registration::Reconnect_attended_by (const Cursor_course &owner) const throw (rdm_exception&) {
    Connect (ATTENDED_BY, owner, TRUE);
}

void Cursor_course_registration::Disconnect_attended_by (void) const throw (rdm_exception&) {
    Disconnect (ATTENDED_BY);
}

Cursor_course Cursor_course_registration::Get_attended_by_owner (void) const throw (rdm_exception&) {
    return GetOwner (ATTENDED_BY);
}

void Cursor_course_registration::SetFieldValues (const struct course_registration *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_course_registration::GetFieldValues (struct course_registration *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

Cursor_course_registration::~Cursor_course_registration () {
}

